globales
	A, B, C: vector[4] de vector[4] de entero;
	a : entero;
fin

funcion sumaMatrices( i, j, nf, nc : entero ) : entero
es
secuencia
	C[i][j] := A[i][j] + B[i][j];
	si j < nc - 1 entonces
		devuelve llama sumaMatrices( i, j + 1, nf, nc );
	si_no
		si i < nf - 1 entonces
			devuelve llama sumaMatrices( i + 1, 0, nf, nc );
		si_no
			devuelve 0;
		fin
	fin
fin

funcion restaMatrices( i, j, nf, nc : entero ) : entero
es
secuencia
    C[i][j] := A[i][j] - B[i][j];
    si j < nc - 1 entonces
        devuelve llama restaMatrices( i, j + 1, nf, nc );
    si_no
        si i < nf - 1 entonces
            devuelve llama restaMatrices( i + 1, 0, nf, nc );
        si_no
            devuelve 0;
        fin
    fin
fin

funcion FilaA( i, j, nc : entero ) : entero
es
secuencia
	escribe A[i][j]; escribe " "; 
	si j < nc - 1 entonces
		devuelve llama FilaA( i, j + 1, nc );
	si_no
		devuelve 0;
	fin
fin

funcion FilaB( i, j, nc : entero ) : entero
es
secuencia
    escribe B[i][j]; escribe " ";
    si j < nc - 1 entonces
        devuelve llama FilaB( i, j + 1, nc );
    si_no
        devuelve 0;
    fin
fin

funcion FilaC( i, j, nc : entero ) : entero
es
secuencia
    escribe C[i][j]; escribe " ";
    si j < nc - 1 entonces
        devuelve llama FilaC( i, j + 1, nc );
    si_no
        devuelve 0;
    fin
fin

funcion muestraResultado( i, nf, nc, op : entero ) : entero
es
locales
	nada : entero;
fin
secuencia
	nada := llama FilaA( i, 0, nc );
	si i = nf / 2 entonces
		si op = 0 entonces
			escribe " +  ";
		si_no
			si op = 1 entonces
				escribe " -  ";
			si_no
				escribe " *  ";
			fin
		fin
	si_no
		escribe "    ";
	fin
	nada := llama FilaB( i, 0, nc );
	si i = nf / 2 entonces
		escribe " =  ";
	si_no
		escribe "    ";
	fin
	nada := llama FilaC( i, 0, nc );
	nl;

	si i < nf - 1 entonces
		devuelve llama muestraResultado( i + 1, nf, nc, op );
	si_no
		devuelve 0;
	fin
fin


funcion multiplicaFilaColumna( f, c, i, n : entero ) : entero
es
secuencia
	si i = n entonces
		devuelve 0;
	si_no
		devuelve ( A[f][i] * B[i][c] ) + llama multiplicaFilaColumna( f, c, i + 1, n );
	fin
fin

funcion productoMatrices( f, c, nf, nc : entero ) : entero
es
secuencia
	C[f][c] := llama multiplicaFilaColumna( f, c, 0, nf );
	si c < nc - 1 entonces
		devuelve llama productoMatrices( f, c + 1, nf, nc );
	si_no
		si f < nf - 1 entonces
			devuelve llama productoMatrices( f + 1, 0, nf, nc );
		si_no
			devuelve 0;
		fin
	fin
fin

secuencia
	A[0][0] := 2;
	A[0][1] := 0;
	A[0][2] := 1;
	A[0][3] := 8;
	A[1][0] := 1;
	A[1][1] := 0;
	A[1][2] := 6;
	A[1][3] := 5;
	A[2][0] := 0;
	A[2][1] := 1;
	A[2][2] := 2;
	A[2][3] := 4;
	A[3][0] := 1;
	A[3][1] := 0;
	A[3][2] := 6;
	A[3][3] := 3;

    B[0][0] := 3;
    B[0][1] := 2;
    B[0][2] := 4;
    B[0][3] := 1;
    B[1][0] := 7;
    B[1][1] := 9;
    B[1][2] := 1;
	B[1][3] := 0;
    B[2][0] := 1;
	B[2][1] := 0;
	B[2][2] := 0;
	B[2][3] := 0;
	B[3][0] := 0;
	B[3][1] := 0;
	B[3][2] := 0;
	B[3][3] := 0;
	
	escribe "------   SUMA DE MATRICES ------"; nl; nl;
	a := llama sumaMatrices( 0, 0, 4, 4 );
	a := llama muestraResultado( 0, 4, 4, 0 );

	nl; escribe "------   RESTA DE MATRICES ------"; nl; nl;
	a := llama restaMatrices( 0, 0, 4, 4 );
	a := llama muestraResultado( 0, 4, 4, 1 );

	nl; escribe "------   PRODUCTO DE MATRICES ------"; nl; nl;
	a := llama productoMatrices( 0, 0, 4, 4 );
	a := llama muestraResultado( 0, 4, 4, 2 );
fin
