globales
	v : vector[15] de entero;
	aux : vector[15] de entero;
	talla : entero;
	nada : entero;
fin

funcion copia( p, q : entero ) : entero
es
secuencia
	si p < q entonces
		secuencia
			v[p] := aux[p];
			devuelve llama copia( p + 1, q );
		fin
	si_no
		devuelve 0;
	fin
fin

funcion merge( p, q, i, j, k : entero ) :  entero
es
secuencia
	si i < ( p + q ) / 2 entonces
		si j < q entonces
			si v[i] < v[j] entonces
				secuencia
					aux[k] := v[i];
					devuelve llama merge( p, q, i + 1, j, k + 1 );
				fin
			si_no
				secuencia
					aux[k] := v[j];
					devuelve llama merge( p, q, i, j + 1, k + 1 );
				fin
			fin
		si_no
			secuencia
				aux[k] := v[i];
				devuelve llama merge( p, q, i + 1, j, k + 1 );
			fin
		fin
	si_no
		si j < q entonces
			secuencia
				aux[k] := v[j];
				devuelve llama merge( p, q, i, j + 1, k + 1 );
			fin
		si_no 
			devuelve llama copia( p, q );
		fin
	fin
fin


funcion mergesort( p, q : entero ) : entero
es
locales
	d : entero;
fin
secuencia
	si q - p > 1 entonces
		secuencia
			d := llama mergesort( p, ( p + q ) / 2 );
			d := llama mergesort( (p + q ) / 2, q );
			d := llama merge( p, q, p, (p + q) /2, p );
		fin
	si_no
		d := 0;
	fin
	devuelve 0;
fin


funcion partition( p, r, pivote, i, j : entero ) : entero
es
locales
	aux : entero;
fin
secuencia
	si j < r - 1 entonces
		secuencia
			si v[j] <= pivote entonces
				secuencia
					i := i + 1;
					aux := v[i]; v[i] := v[j]; v[j] := aux;
				fin
			si_no
				aux := 0;
			fin
			devuelve llama partition( p, r, pivote, i, j + 1 );
		fin
	si_no
		secuencia
			aux := v[ i + 1 ];
			v[ i + 1 ] := v[ r - 1];
			v[ r - 1 ] := aux;
			devuelve i + 1;
		fin
	fin	
fin


funcion quicksort( p, r : entero ) : entero
es
locales
	indice_pivote, a : entero;
fin
secuencia
	si r - p > 1 entonces
		secuencia
			indice_pivote := llama partition( p, r, v[ r - 1 ], p - 1, p );
			a := llama quicksort( p, indice_pivote );
			a := llama quicksort( indice_pivote + 1, r );
			devuelve a;
		fin
	si_no
		devuelve 0;
	fin
fin

funcion muestra( i : entero ) : entero
es
locales
	a : entero;
fin
secuencia
	si i = 0 entonces
		escribe "[";
	si_no
		a := 0;
	fin

	si i < talla - 1 entonces
		secuencia
			escribe v[i]; escribe ", ";
			devuelve llama muestra( i + 1 );
		fin
	si_no
		secuencia
			escribe v[i]; escribe "]"; nl;
			devuelve 0;	
		fin
	fin
	devuelve 0;
fin

secuencia
	escribe "######    PRUEBA DE MERGESORT    ######"; nl;
	v[0] := 25;
	v[1] := 95;
	v[2] := 15;
	v[3] := 75;
	v[4] := 55;
	v[5] := 12;
	v[6] := 2;
	v[7] := 1;
	v[8] := 4;
	v[9] := 39;
	v[10] := 96;
	v[11] := 99;
	v[12] := 18;
	v[13] := 57;
	v[14] := 78;
	talla := 15;

	escribe "Vector inicial: ";
	nada := llama muestra( 0 );
	nada := llama mergesort( 0, talla );
	escribe "Vector ordenado con mergesort: ";
	nada := llama muestra( 0 ); nl;

	v[0] := 27;
    v[1] := 52;
    v[2] := 215;
    v[3] := 975;
    v[4] := 15;
    v[5] := 18;
    v[6] := 20;
    v[7] := 100;
    v[8] := 40;
    v[9] := 25;
    v[10] := 39;
    v[11] := 155;
    v[12] := 1008;
    v[13] := 366;
    v[14] := 36;
    escribe "Vector inicial: ";
    nada := llama muestra( 0 );
    nada := llama mergesort( 0, talla );
    escribe "Vector ordenado con mergesort: ";
    nada := llama muestra( 0 ); nl;


	escribe "######    PRUEBA DE QUICKSORT    ######"; nl;
	v[0] := 25;
	v[1] := 95;
	v[2] := 15;
	v[3] := 75;
	v[4] := 55;
	v[5] := 12;
	v[6] := 2;
	v[7] := 1;
	v[8] := 4;
	v[9] := 39;
	v[10] := 96;
	v[11] := 99;
	v[12] := 18;
	v[13] := 57;
	v[14] := 78;
	talla := 15;

	escribe "Vector inicial: ";
	nada := llama muestra( 0 );
	nada := llama quicksort( 0, talla );
	escribe "Vector ordenado con quicksort: ";
	nada := llama muestra( 0 ); nl;

	v[0] := 27;
    v[1] := 52;
    v[2] := 215;
    v[3] := 975;
    v[4] := 15;
    v[5] := 18;
    v[6] := 20;
    v[7] := 100;
    v[8] := 40;
    v[9] := 25;
    v[10] := 39;
    v[11] := 155;
    v[12] := 1008;
    v[13] := 366;
    v[14] := 36;
    escribe "Vector inicial: ";
    nada := llama muestra( 0 );
    nada := llama quicksort( 0, talla );
    escribe "Vector ordenado con quicksort: ";
    nada := llama muestra( 0 ); nl;
fin
