globales
	v : vector[5] de entero;
	talla, nada : entero;
fin

funcion factorial( x : entero ) : entero
es
secuencia
    si x = 1 entonces
        devuelve 1;
    si_no
        devuelve x * llama factorial( x - 1 );
    fin
fin

funcion fibonacci( n : entero ) : entero
es
secuencia
    si n <= 2 entonces
        devuelve 1;
    si_no
        devuelve ( llama fibonacci( n - 1 ) + llama fibonacci( n - 2 ) );
    fin
fin

funcion hanoi( N : entero ; A, B, C : cadena ) : cadena
es
secuencia
    si N = 1 entonces
        secuencia
            escribe "Pasar disco de "; escribe A; escribe " a "; escribe B; nl;
        fin
    si_no
        secuencia
            escribe llama hanoi( N - 1, A, C, B );
            escribe "Pasar disco de "; escribe A; escribe " a "; escribe B; nl;
            escribe llama hanoi( N - 1, C, B, A );
        fin
    fin
    devuelve "";
fin

funcion busqueda_binaria( i, k, b : entero ) : entero
es
locales
	j : entero;
fin
secuencia
	si k - i = 1 entonces
		si b = v[i] entonces
			devuelve i;
		si_no
			devuelve 0;
		fin
	si_no
		secuencia
			j := (i + k) / 2;
			si b = v[j] entonces
				devuelve j;
			si_no
				si b < v[j] entonces
					devuelve llama busqueda_binaria( i, j, b );
				si_no
					devuelve llama busqueda_binaria( j + 1, k, b );
				fin
			fin
		fin
	fin		
fin

funcion muestra( i : entero ) : entero
es
locales
    a : entero;
fin
secuencia
    si i = 0 entonces
        escribe "[";
    si_no
        a := 0;
    fin

    si i < talla - 1 entonces
        secuencia
            escribe v[i]; escribe ", ";
            devuelve llama muestra( i + 1 );
        fin
    si_no
        secuencia
            escribe v[i]; escribe "]"; nl;
            devuelve 0;
        fin
    fin
    devuelve 0;
fin

funcion power( a, n : entero ) : entero
es
secuencia
	si n = 0 entonces
		devuelve 1;
	si_no
		si n = 1 entonces
			devuelve a;
		si_no
			si n % 2 = 0 entonces
				devuelve llama power( a, n/2 ) * llama power( a, n/2 );
			si_no
				devuelve llama power( a, n/2 ) * llama power( a, n/2 + 1 );
			fin
		fin
	fin
fin

secuencia
	escribe "---------  Probamos el factorial  ---------";
    escribe "Factorial de 5: "; escribe llama factorial( 5 ); nl;
    escribe "Factorial de 6: "; escribe llama factorial( 6 ); nl;
    escribe "Factorial de 7: "; escribe llama factorial( 7 ); nl;
    escribe "Factorial de 10: "; escribe llama factorial( 10 ); nl;
    escribe "Factorial de 20: "; escribe llama factorial( 20 ); nl; nl;

	escribe "---------  Probamos hanoi  -----------------";
	escribe llama hanoi( 10, "A", "C", "B" ); nl;

	escribe "--------- Probamos fibonacci ---------------"; nl;
    escribe llama fibonacci( 5 ); nl;
    escribe llama fibonacci( 6 ); nl;
    escribe llama fibonacci( 7 ); nl;
    escribe llama fibonacci( 8 ); nl;
    escribe llama fibonacci( 9 ); nl;
    escribe llama fibonacci( 10 ); nl;
    escribe llama fibonacci( 11 ); nl;
    escribe llama fibonacci( 12 ); nl;
    escribe llama fibonacci( 13 ); nl;
    escribe llama fibonacci( 14 ); nl;
    escribe llama fibonacci( 15 ); nl;

	escribe "--------- Probamos la busqueda binaria -----"; nl;
	talla := 5;
	v[0] := 12;
	v[1] := 15;
	v[2] := 17;
	v[3] := 18;
	v[4] := 19;
	escribe "Vector: "; nada := llama muestra( 0 );
	escribe "Posicion de 15: "; escribe llama busqueda_binaria( 0, 5, 15 ); nl;
	escribe "Posicion de 18: "; escribe llama busqueda_binaria( 0, 5, 18 ); nl;
	escribe "Posicion de 19: "; escribe llama busqueda_binaria( 0, 5, 19 ); nl;

	escribe "--------- Probamos las potencias -----"; nl;
	escribe "2 ** 30: "; escribe llama power( 2, 30 ); nl;
	escribe "5 ** 12: "; escribe llama power( 5, 12 ); nl;
	escribe "12 ** 5: "; escribe llama power( 12, 5 ); nl;
	escribe "30 ** 2: "; escribe llama power( 30, 2 ); nl;
	escribe "3 ** 3: "; escribe llama power( 3, 3 ); nl;
fin

